<?php if ( !defined( 'ABSPATH' ) ) exit;//PHPの宣言と直接アクセスの拒否
/*** 設定を追加したらサニタイズ関数の条件も追加すること ***/

/* セクションID haumenu_define_section_id_04_optimize() */
/* タブのスラグ haumenu_define_tab_slug_04_optimize() */
/* $option_name 設定名 haumenu_define_option_name_04_optimize() */
/* get_option GetOP04_optimize() */

/***** 親設定の有効／無効に合わせて子設定の表示方法を変更する *****/
/* 関数名・設定名は画面ごとに変えること（関数重複を防ぐ） */
/* add_action('admin_notices', 'current_pagehook');を追加してページ名を取得し、$page_fooksuffixの値を変える */
/* 連動マップ（ID => セレクター）の項目を編集する */

function haup_child_setting_view_control_04_optimize( $hook_suffix ) {
	//ページフックにより出力を判断
	$page_fooksuffix = 'ha-utilitiy_page_haumenu_page_optimize';

	if ( $page_fooksuffix !== $hook_suffix ) {
		return;
	}

	//メインスクリプトのハンドル
	$handle = 'haup-child-setting-control-js';

	// メインスクリプトが登録されていなければ終了(スクリプトの読み込みはmain-menu.phpで記述)
	if ( ! wp_script_is( $handle, 'registered' ) ) {
		return;
	}

	//設定名
	$set_name = haumenu_define_option_name_04_optimize();

	// 連動マップ（ID => セレクター）
	// 1つのIDに対して複数のCSSクラスを指定する（1つなら1行）
	$dependency_map = array(
		$set_name . 'enable-smtp-auth' => array(
			'.smtp-host-name-wrapper', // ホスト名
			'.smtp-encryption-wrapper', // SMTP暗号化方式
			'.smtp-port-wrapper', // ポート番号
			'.smtp-user-name-wrapper', // SMTP ユーザー名
			'.smtp-password-wrapper', // SMTP パスワード
		),

	);

	$inner_js = "";
	foreach ( $dependency_map as $id => $selectors ) {
		foreach ( (array) $selectors as $selector ) {
			// translators: %s stands for the CSS Class & ID.
			$inner_js .= sprintf(
				"haup_apply_dependency('%s', '%s');\n",
				esc_js( $id ),
				esc_js( $selector )
			);
		}
	}

	if ( $inner_js ) {
		$js_code = "if (window.haup_apply_dependency) {\n" . $inner_js . "}";
		// 第3引数を 'after' にすることで、本体JSの直後に出力
		wp_add_inline_script( $handle, $js_code, 'after' );
	}
}
add_action( 'admin_enqueue_scripts', 'haup_child_setting_view_control_04_optimize', 20 );

/*** SMTP Authの有効化 ***/
/* 項目の追加とデータの更新 */
function haumenu_init_field_enable_smtp_auth(){
//項目の追加
	add_settings_field(
		'enable-smtp-auth', // $id フィールドを識別するスラッグ名
		__('Enable SMTP-AUTH','hima-art-utility'), // $title 設定タイトル
		'haumenu_enable_smtp_auth', // $callback 設定項目のHTMLを出力する関数名
		haumenu_define_tab_slug_04_optimize(), //表示させるタブのスラグ
		haumenu_define_section_id_04_optimize(),// $section 表示させるセクションのID
		array( 'class' => 'ha-settings-separate' )
	);

}
add_action( 'admin_init', 'haumenu_init_field_enable_smtp_auth' );

/* 入力フォーム */
function haumenu_enable_smtp_auth() {
	$set_name = haumenu_define_option_name_04_optimize(); //  $option_name 設定名
	$options = get_option($set_name);
	$option_name = 'enable-smtp-auth'; //個別配列名

	//テーブルに値がなかった場合の措置（PHP8.x以降への対応）
	if(isset($options[$option_name])){
		$checked = $options[$option_name];
	}else{
		$checked = '';
	}
?>
<label>
	<input type="checkbox" id="<?php echo esc_html($set_name . $option_name ); ?>" name="<?php echo esc_html($set_name . '[' .$option_name. ']'); ?>" class="wppd-ui-toggle" <?php checked( $checked , 1 ); ?> value="1">
<p><?php esc_html_e('Enable when sending emails via SMTP-AUTH','hima-art-utility'); ?></p>
</label>
<?php
}

/*** ホスト名 ***/
function haumenu_init_field_smtp_host_name() {
// フィールドの追加
	add_settings_field(
		'smtp-host-name', // $id フィールドを識別するスラッグ名（一意）
		__('Mail server host name','hima-art-utility'), // $title 設定タイトル
		'haumenu_smtp_host_name', // $callback 設定項目のHTMLを出力する関数名
		haumenu_define_tab_slug_04_optimize(), //表示させるタブのスラグ
		haumenu_define_section_id_04_optimize(),// $section 表示させるセクションのID
		array( 'class' => 'ha-settings-convine' )
    );
}
add_action('admin_init', 'haumenu_init_field_smtp_host_name');

/* 入力フォーム */
function haumenu_smtp_host_name(){
	$set_name = haumenu_define_option_name_04_optimize(); //  $option_name 設定名
	$options = get_option($set_name);
	$option_name = 'smtp-host-name'; //個別配列名
?>
<div class="smtp-host-name-wrapper">
<label>
	<input name="<?php echo esc_html($set_name . '['.$option_name.']'); ?>" type="text" class="transform" id="<?php echo esc_html($set_name . $option_name ); ?>" value="<?php echo esc_attr($options[ $option_name ] ?? ''); ?>">
</label>
	<p><?php esc_html_e('Enter the host name of your mail server','hima-art-utility'); ?></p>
</div>
<?php
}

/* SMTP暗号化方式 */
/* 項目の追加とデータの更新 */
function haumenu_init_field_select_smtp_encryption(){
//項目の追加
	add_settings_field(
		'smtp-encryption',// $id フィールドを識別するスラッグ名
		__('SMTP Encryption method','hima-art-utility'),// $title 設定タイトル
		'haumenu_select_smtp_encryption', // $callback 設定項目のHTMLを出力する関数名
		haumenu_define_tab_slug_04_optimize(), //表示させるタブのスラグ
		haumenu_define_section_id_04_optimize(),// $section 表示させるセクションのID
		array( 'class' => 'ha-settings-convine' )
	);
}

add_action( 'admin_init', 'haumenu_init_field_select_smtp_encryption' );

/* 入力フォーム */
function haumenu_select_smtp_encryption() {
	$set_name = haumenu_define_option_name_04_optimize(); //  $option_name 設定名
	$options = get_option($set_name);
	$option_name = 'smtp-encryption'; //個別配列名

	if(isset($options[$option_name])){
		$selected = $options[$option_name];
	}else{
		$selected = '';
	}
?>
<div class="smtp-encryption-wrapper">
<select name= '<?php echo esc_html($set_name . '[' .$option_name. ']'); ?>' >
<option value='1' <?php selected($selected , 1 ); ?> selected ><?php esc_html_e('Use SSL', 'hima-art-utility'); ?></option>
<option value='2' <?php selected($selected , 2 ); ?>><?php esc_html_e('Use TLS', 'hima-art-utility'); ?></option>
</select>
</div>
<?php
}

/*** ポート番号 ***/
function haumenu_init_field_smtp_port_number(){
//項目の追加
	add_settings_field(
		'smtp-port',//  $option_name 設定名
		__('SMTP port number','hima-art-utility'),// $title 設定タイトル
		'haumenu_smtp_port_number', // $callback 設定項目のHTMLを出力する関数名
		haumenu_define_tab_slug_04_optimize(), //表示させるタブのスラグ
		haumenu_define_section_id_04_optimize(),// $section 表示させるセクションのID
		array( 'class' => 'ha-settings-convine' )
	);

}

add_action( 'admin_init', 'haumenu_init_field_smtp_port_number' );

/* 入力フォーム */
function haumenu_smtp_port_number() {
	$set_name = haumenu_define_option_name_04_optimize(); //  $option_name 設定名
	$options = get_option($set_name);
	$option_name = 'smtp-port'; //個別配列名
?>
<div class="smtp-port-wrapper">
<label>
	<input name="<?php echo esc_html($set_name . '['.$option_name.']'); ?>" type="text" class="transform" id="<?php echo esc_html($set_name . $option_name ); ?>" value="<?php echo esc_attr($options[ $option_name ] ?? ''); ?>">
	<p><?php esc_html_e('Enter SMTP port number','hima-art-utility'); ?></p>
</label>
<p class="haup-admin-bk"><?php esc_html_e('Generally, it is "465" for SSL and "587" for TLS, but it may differ depending on the server, so please check the manual of your mail server for the correct value.','hima-art-utility'); ?></p>
</div>
<?php
}

/*** SMTP ユーザー名 ***/
function haumenu_init_field_smtp_user_name(){
//項目の追加
	add_settings_field(
		'smtp-user-name',//  $option_name 設定名
		__('Mail server user name','hima-art-utility'),// $title 設定タイトル
		'haumenu_smtp_user_name', // $callback 設定項目のHTMLを出力する関数名
		haumenu_define_tab_slug_04_optimize(), //表示させるタブのスラグ
		haumenu_define_section_id_04_optimize(),// $section 表示させるセクションのID
		array( 'class' => 'ha-settings-convine' )
	);
}
add_action( 'admin_init', 'haumenu_init_field_smtp_user_name' );

/* 入力フォーム */
function haumenu_smtp_user_name() {
	$set_name = haumenu_define_option_name_04_optimize(); //  $option_name 設定名
	$options = get_option($set_name);
	$option_name = 'smtp-user-name'; //個別配列名
?>
<div class="smtp-user-name-wrapper">
<label>
	<input name="<?php echo esc_html($set_name . '['.$option_name.']'); ?>" type="text" class="transform" id="<?php echo esc_html($set_name . $option_name ); ?>" value="<?php echo esc_attr($options[ $option_name ] ?? ''); ?>">
	<p><?php esc_html_e('Enter your username to connect to your mail server','hima-art-utility'); ?></p>
</label>
</div>
<?php
}

/*** SMTP パスワード ***/
function haumenu_init_field_smtp_password(){
//項目の追加
	add_settings_field(
		'smtp-password',//  $option_name 設定名
		__('Mail server password','hima-art-utility'),// $title 設定タイトル
		'haumenu_smtp_password', // $callback 設定項目のHTMLを出力する関数名
		haumenu_define_tab_slug_04_optimize(), //表示させるタブのスラグ
		haumenu_define_section_id_04_optimize(),// $section 表示させるセクションのID
		array( 'class' => 'ha-settings-convine' )
	);
}

add_action( 'admin_init', 'haumenu_init_field_smtp_password' );

/* 入力フォーム */
function haumenu_smtp_password() {
	$set_name = haumenu_define_option_name_04_optimize(); //  $option_name 設定名
	$options = get_option($set_name);
	$option_name = 'smtp-password'; //個別配列名
?>
<div class="smtp-password-wrapper">
<label>
	<input name="<?php echo esc_html($set_name . '['.$option_name.']'); ?>" type="text" class="transform" id="<?php echo esc_html($set_name . $option_name ); ?>" value="<?php echo esc_attr($options[ $option_name ] ?? ''); ?>">
	<p><?php esc_html_e('Enter your password to connect to your mail server','hima-art-utility'); ?></p>
</label>
</div>
<?php
}